"use strict";Object.defineProperty(exports,"__esModule",{value:!0});var e=require("tedious"),t=require("itee-database"),r=require("itee-validators");function n(e){if(e&&e.__esModule)return e;var t=Object.create(null);return e&&Object.keys(e).forEach((function(r){if("default"!==r){var n=Object.getOwnPropertyDescriptor(e,r);Object.defineProperty(t,r,n.get?n:{enumerable:!0,get:function(){return e[r]}})}})),t.default=e,Object.freeze(t)}var o=n(e);
/**
 * @author [Ahmed DCHAR]{@link https://github.com/dragoneel}
 * @license [BSD-3-Clause]{@link https://opensource.org/licenses/BSD-3-Clause}
 *
 * @file Todo
 *
 * @example Todo
 *
 */class a extends t.TAbstractDatabase{constructor(e={}){const t={server:"localhost",authentication:{type:"default",options:{userName:"user",password:"password",domain:""}},options:{abortTransactionOnError:!1,appName:void 0,camelCaseColumns:!1,cancelTimeout:5e3,columnNameReplacer:void 0,connectionRetryInterval:500,connectTimeout:15e3,cryptoCredentialsDetails:{},database:void 0,datefirst:7,dateFormat:"mdy",debug:{data:!1,packet:!1,payload:!1,token:!1},enableAnsiNull:!0,enableAnsiNullDefault:!0,enableAnsiPadding:!0,enableAnsiWarnings:!0,enableArithAbort:!1,enableConcatNullYieldsNull:!0,enableCursorCloseOnCommit:null,enableImplicitTransactions:!1,enableNumericRoundabort:!1,enableQuotedIdentifier:!0,encrypt:!1,fallbackToDefaultDb:!1,instanceName:void 0,language:"us_english",localAddress:void 0,maxRetriesOnTransientErrors:3,multiSubnetFailover:!1,packetSize:4096,port:1433,readOnlyIntent:!1,requestTimeout:15e3,rowCollectionOnDone:!1,rowCollectionOnRequestCompletion:!1,tdsVersion:"7_4",textsize:2147483647,trustServerCertificate:!0,useColumnNames:!1,useUTC:!0},...e};t.driver={SqlServerDriver:o,Connection:new o.Connection(t),Request:o.Request},super(t)}close(e){this.driver.Connection.close(),e()}connect(){this.driver.Connection.on("connect",(e=>{if(e)return void this.logger.error(e);const t=this.driver.Connection.config,r=t.server,n=t.options.port,o=t.options.database;this.logger.log(`SQLServer at ms-sql-s://${r}:${n}/${o} is connected !`)}))}init(){super.init()}on(){}}
/**
 * @author [Tristan Valcke]{@link https://github.com/Itee}
 * @license [BSD-3-Clause]{@link https://opensource.org/licenses/BSD-3-Clause}
 *
 * @class TSQLServerController
 * @classdesc The TSQLServerController is the base class to perform CRUD operations on the database
 */class s extends t.TAbstractDataController{constructor(e={}){const t={driver:null,tableName:"",columns:[],...e};super(t),this.tableName=t.tableName,this.columns=t.columns}get tableName(){return this._tableName}set tableName(e){const t="Expect an instance of String.";if(r.isNull(e))throw new TypeError(`Table name cannot be null ! ${t}`);if(r.isUndefined(e))throw new TypeError(`Table name cannot be undefined ! ${t}`);if(r.isNotString(e))throw new TypeError(`Table name cannot be an instance of ${e.constructor.name} ! ${t}`);this._tableName=e}get columns(){return this._columns}set columns(e){const t="Expect an array of strings.";if(r.isNull(e))throw new TypeError(`Columns cannot be null ! ${t}`);if(r.isUndefined(e))throw new TypeError(`Columns cannot be undefined ! ${t}`);if(r.isNotArrayOfString(e))throw new TypeError(`Columns cannot be an instance of ${e.constructor.name} ! ${t}`);this._columns=e}setTableName(e){return this.tableName=e,this}setColumns(e){return this.columns=e,this}_createMany(e,t){super._createMany(e,t);const n=this.columns,o=n.toString();let a=null,s="",i=null;for(let t=0,o=e.length;t<o;t++){a=e[t],s+="(";for(let e in a)n.includes(e)&&(i=a[e],r.isString(i)?s+=`'${i}', `:s+=`${i}, `);s=s.slice(0,-2),s+="), "}s=s.slice(0,-2);const l=`INSERT INTO ${this._tableName} (${o}) VALUES ${s}`,c=new this._driver.Request(l,this.return(t));this._driver.Connection.execSql(c)}_createOne(e,t){super._createOne(e,t);const n=this.columns;let o="",a=null,s="",i=null;for(let t=0,l=n.length;t<l;t++)a=n[t],i=e[a],i&&(o+=`${a}, `,r.isString(i)?s+=`'${i}', `:s+=`${i}, `);o=o.slice(0,-2),s=s.slice(0,-2);const l=`INSERT INTO ${this._tableName} (${o}) VALUES (${s})`,c=new this._driver.Request(l,this.return(t));this._driver.Connection.execSql(c)}_deleteAll(e){super._deleteAll(e);const t=`TRUNCATE TABLE ${this._tableName}`,r=new this._driver.Request(t,this.return(e));this._driver.Connection.execSql(r)}_deleteMany(e,t){super._deleteMany(e,t);const r=`DELETE FROM ${this._tableName} WHERE id IN (${e})`,n=new this._driver.Request(r,this.return(t));this._driver.Connection.execSql(n)}_deleteOne(e,t){super._deleteOne(e,t);const r=`DELETE FROM ${this._tableName} WHERE id=${e}`,n=new this._driver.Request(r,this.return(t));this._driver.Connection.execSql(n)}_deleteWhere(e,r){super._deleteWhere(e,r),t.TAbstractDataController.returnError("Unimplemented methods (DELETE WHERE)",r)}_readAll(e,r){super._readAll(e,r);const n=`SELECT * FROM ${this.tableName}`,o=new this._driver.Request(n,((e,n,o)=>{e?t.TAbstractDataController.returnError(e,r):0===o.length?t.TAbstractDataController.returnNotFound(r):t.TAbstractDataController.returnData(o,r)}));o.on("row",(e=>{let t={};e.forEach((e=>{t[e.metadata.colName]=e.value}))})),this._driver.Connection.execSql(o)}_readMany(e,r,n){super._readMany(e,r,n);const o=e.toString(),a=`SELECT * FROM ${this.tableName} WHERE id IN (${o})`,s=new this._driver.Request(a,((e,r,o)=>{e?t.TAbstractDataController.returnError(e,n):0===o.length?t.TAbstractDataController.returnNotFound(n):t.TAbstractDataController.returnData(o,n)}));s.on("row",(e=>{let t={};e.forEach((e=>{t[e.metadata.colName]=e.value}))})),this._driver.Connection.execSql(s)}_readOne(e,r,n){super._readOne(e,r,n);const o=`SELECT * FROM ${this.tableName} WHERE id=${e}`,a=new this._driver.Request(o,((e,r,o)=>{e?t.TAbstractDataController.returnError(e,n):0===o.length?t.TAbstractDataController.returnNotFound(n):t.TAbstractDataController.returnData(o,n)}));a.on("row",(e=>{let t={};e.forEach((e=>{t[e.metadata.colName]=e.value}))})),this._driver.Connection.execSql(a)}_readWhere(e,r,n){super._readWhere(e,r,n),t.TAbstractDataController.returnError("Unimplemented methods (READ WHERE)",n)}_updateAll(e,t){super._updateAll(e,t);let n="";for(let t in e){const o=e[t];r.isString(o)?n+=`${t} = '${o}', `:n+=`${t} = ${o}, `}n=n.slice(0,-2);const o=`UPDATE ${this._tableName} SET ${n}`,a=new this._driver.Request(o,this.return(t));this._driver.Connection.execSql(a)}_updateMany(e,t,n){super._updateMany(e,t,n);let o="",a=null;for(let e in t)a=t[e],r.isString(a)?o+=`${e} = '${a}', `:o+=`${e} = ${a}, `;o=o.slice(0,-2);const s=`UPDATE ${this._tableName} SET ${o} WHERE id IN (${e})`,i=new this._driver.Request(s,this.return(n));this._driver.Connection.execSql(i)}_updateOne(e,t,n){super._updateOne(e,t,n);let o="",a=null;for(let e in t)a=t[e],r.isString(a)?o+=`${e} = '${a}', `:o+=`${e} = ${a}, `;o=o.slice(0,-2);const s=`UPDATE ${this._tableName} SET ${o} WHERE id=${e}`,i=new this._driver.Request(s,this.return(n));this._driver.Connection.execSql(i)}_updateWhere(e,r,n){super._updateWhere(e,r,n),t.TAbstractDataController.returnError("Unimplemented methods (UPDATE WHERE)",n)}}exports.TSQLServerController=s,exports.TSQLServerDatabase=a;
